• 原题如下:

    Traveling by Stagecoach
    Time Limit: 2000MS   Memory Limit: 65536K
    Total Submissions: 4494   Accepted: 1852   Special Judge

    Description

    Once upon a time, there was a traveler.

    He plans to travel using stagecoaches (horse wagons). His starting point and destination are fixed, but he cannot determine his route. Your job in this problem is to write a program which determines the route for him.

    There are several cities in the country, and a road network connecting them. If there is a road between two cities, one can travel by a stagecoach from one of them to the other. A coach ticket is needed for a coach ride. The number of horses is specified in each of the tickets. Of course, with more horses, the coach runs faster.

    At the starting point, the traveler has a number of coach tickets. By considering these tickets and the information on the road network, you should find the best possible route that takes him to the destination in the shortest time. The usage of coach tickets should be taken into account.

    The following conditions are assumed.

    • A coach ride takes the traveler from one city to another directly connected by a road. In other words, on each arrival to a city, he must change the coach.
    • Only one ticket can be used for a coach ride between two cities directly connected by a road.
    • Each ticket can be used only once.
    • The time needed for a coach ride is the distance between two cities divided by the number of horses.
    • The time needed for the coach change should be ignored.

    Input

    The input consists of multiple datasets, each in the following format. The last dataset is followed by a line containing five zeros (separated by a space).

    n m p a b 
    t1 t2 ... tn 
    x1 y1 z1 
    x2 y2 z2 
    ... 
    xp yp zp

    Every input item in a dataset is a non-negative integer. If a line contains two or more input items, they are separated by a space.

    n is the number of coach tickets. You can assume that the number of tickets is between 1 and 8. m is the number of cities in the network. You can assume that the number of cities is between 2 and 30. p is the number of roads between cities, which may be zero.

    a is the city index of the starting city. b is the city index of the destination city. a is not equal to b. You can assume that all city indices in a dataset (including the above two) are between 1 and m.

    The second line of a dataset gives the details of coach tickets. ti is the number of horses specified in the i-th coach ticket (1<=i<=n). You can assume that the number of horses is between 1 and 10.

    The following p lines give the details of roads between cities. The i-th road connects two cities with city indices xi and yi, and has a distance zi (1<=i<=p). You can assume that the distance is between 1 and 100.

    No two roads connect the same pair of cities. A road never connects a city with itself. Each road can be traveled in both directions.

    Output

    For each dataset in the input, one line should be output as specified below. An output line should not contain extra characters such as spaces.

    If the traveler can reach the destination, the time needed for the best route (a route with the shortest time) should be printed. The answer should not have an error greater than 0.001. You may output any number of digits after the decimal point, provided that the above accuracy condition is satisfied.

    If the traveler cannot reach the destination, the string "Impossible" should be printed. One cannot reach the destination either when there are no routes leading to the destination, or when the number of tickets is not sufficient. Note that the first letter of "Impossible" is in uppercase, while the other letters are in lowercase.

    Sample Input

    3 4 3 1 4
    3 1 2
    1 2 10
    2 3 30
    3 4 20
    2 4 4 2 1
    3 1
    2 3 3
    1 3 3
    4 1 2
    4 2 5
    2 4 3 4 1
    5 5
    1 2 10
    2 3 10
    3 4 10
    1 2 0 1 2
    1
    8 5 10 1 5
    2 7 1 8 4 5 6 3
    1 2 5
    2 3 4
    3 4 7
    4 5 3
    1 3 25
    2 4 23
    3 5 22
    1 4 45
    2 5 51
    1 5 99
    0 0 0 0 0

    Sample Output

    30.000
    3.667
    Impossible
    Impossible
    2.856

    Hint

    Since the number of digits after the decimal point is not specified, the above result is not the only solution. For example, the following result is also acceptable.

    30.0

    3.66667

    Impossible

    Impossible

    2.85595
  • 题解:如果把城市看作顶点,道路看作边建图,由于有车票相关的限制,无法直接使用Dijkstra算法求解。不过,这种情况下只需要把状态作为顶点,而把状态的转移看成边建图就可以很好地避免这个问题。考虑"现在在城市v,此时还剩下的车票的集合为S"这样的状态,从这个状态出发,使用一张车票i∈S移动到相邻的城市u,就相当于转移到了"在城市u,此时还剩下的车票的集合为S\{i}"这个状态。把这个转移看成一条边,那么边上的花费是(v-u间道路的长度)/ti。按照上述的方法所构的图就可以用Dijkstra算法求解了。集合S使用状态压缩的方法表示就可以了。由于剩余的车票的集合S随着移动元素个数不断变小,因此这个图实际上一个DAG,计算DAG的最短路不需要是用Dijkstra算法,可以简单地通过DP求解。
  • 代码:
     #include <cstdio>
    #include <cstdio>
    #include <cctype>
    #include <cstring>
    #include <algorithm>
    #define number s-'0' using namespace std; const int INF=0x3f3f3f3f;
    const int MAX_N=;
    const int MAX_M=;
    int n,m,p,a,b;
    int t[MAX_N];
    int d[MAX_M][MAX_M];
    double dp[<<MAX_N][MAX_M]; void read(int &x)
    {
    char s;
    x=;
    bool flag=;
    while(!isdigit(s=getchar()))
    (s=='-')&&(flag=true);
    for(x=number;isdigit(s=getchar());x=x*+number);
    (flag)&&(x=-x);
    } double min(double x, double y)
    {
    if (x<=y) return x;
    return y;
    } int main()
    {
    read(n);read(m);read(p);read(a);read(b);
    while (n+m+p+a+b)
    {
    for (int i=; i<n; i++) read(t[i]);
    memset(d, -, sizeof(d));
    for (int i=; i<p; i++)
    {
    int x, y, z;
    read(x);read(y);read(z);
    x--;y--;
    x[y[d]]=y[x[d]]=z;
    }
    for (int i=; i<<<n; i++)
    {
    fill(dp[i], dp[i]+m, INF);
    }
    dp[(<<n)-][a-]=;
    double res=INF;
    for (int S=(<<n)-; S>=; S--)
    {
    res=min(res, dp[S][b-]);
    for (int v=; v<m; v++)
    {
    for (int i=; i<n; i++)
    {
    if ((S>>i)&)
    {
    for (int u=; u<m; u++)
    {
    if (d[v][u]>=)
    {
    dp[S&~(<<i)][u]=min(dp[S&~(<<i)][u],dp[S][v]+d[v][u]/(double)t[i]);
    }
    }
    }
    }
    }
    }
    if (res==INF) puts("Impossible");
    else printf("%.3f\n", res);
    read(n);read(m);read(p);read(a);read(b);
    }
    }

Traveling by Stagecoach(POJ 2686)的更多相关文章

  1. POJ 2686 Traveling by Stagecoach(状压二维SPFA)

    Traveling by Stagecoach Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 3407   Accepted ...

  2. poj2686 Traveling by Stagecoach

                    http://poj.org/problem?id=2686                                                  Trav ...

  3. Traveling by Stagecoach 状态压缩裸题

    Traveling by Stagecoach dp[s][v]  从源点到达  v,状态为s,v的最小值.  for循环枚举就行了. #include <iostream> #inclu ...

  4. poj 2686 Traveling by Stagecoach ---状态压缩DP

    题意:给出一个简单带权无向图和起止点,以及若干张马车车票,每张车票可以雇到相应数量的马. 点 u, v 间有边时,从 u 到 v 或从 v 到 u 必须用且仅用一张车票,花费的时间为 w(u, v) ...

  5. POJ 2686 Traveling by Stagecoach(状压DP)

    [题目链接] http://poj.org/problem?id=2686 [题目大意] 给出一张无向图,你有n张马车票每张车票可以租用ti匹马, 用一张马车票从一个城市到另一个城市所用的时间为这两个 ...

  6. POJ 2686 Traveling by Stagecoach 壮压DP

    大意是有一个人从某个城市要到另一个城市(点数<=30) 然后有n个马车票,相邻的两个城市走的话要消耗掉一个马车票. 花费的时间呢,是马车票上有个速率值,用边/速率就是花的时间. 问最后这个人花费 ...

  7. POJ 2686 Traveling by Stagecoach

    状压DP dp[s][p]用了哪几张票,到哪个节点的最小费用. 注意:G++ %.3lf输出会WA,但C++能过:改成%.3f,C++,G++都能AC #include<cstdio> # ...

  8. POJ 2686 Traveling by Stagecoach (状压DP)

    题意:有一个人从某个城市要到另一个城市, 有n个马车票,相邻的两个城市走的话要消耗掉一个马车票.花费的时间呢,是马车票上有个速率值 ,问最后这个人花费的最短时间是多少. 析:和TSP问题差不多,dp[ ...

  9. POJ2686 Traveling by Stagecoach(状压DP+SPFA)

    题目大概是给一张有向图,有n张票,每张票只能使用一次,使用一张票就能用pi匹马拉着走过图上的一条边,走过去花的时间是边权/pi,问从a点走到b点的最少时间是多少. 用dp[u][S]表示当前在u点且用 ...

随机推荐

  1. Redis持久化存储——>RDB & AOF

    Redis中两种持久化存储机制RDB和AOF redis是一个内存数据库,数据保存在内存中,但是我们都知道内存的数据变化是很快的,也容易发生丢失.幸好Redis还为我们提供了持久化的机制,分别是RDB ...

  2. peewee的简单使用

    peewee的简单使用 peewee是一个轻量级的ORM框架,peewee完全可以应对个人或企业的中小型项目的Model层,上手容易,功能强大. 一.安装peewee模块 使用pip命令工具安装pee ...

  3. 强化学习中的经验回放(The Experience Replay in Reinforcement Learning)

    一.Play it again: reactivation of waking experience and memory(Trends in Neurosciences 2010) SWR发放模式不 ...

  4. Latex — 写作编译过程中遇到问题记录与总结

    最近在训练的时候,又开始用Latex进行写作.碰到了很多问题,将问题进行记录与总结. 一.输出中文的问题 由于写作的时候用的是中文,而之前用的是英文,故碰到的第一个问题就是中文的问题.我之前下的是Wi ...

  5. 牛客网PAT练兵场-组个最小数

    题解:从小到大输出 题目地址:https://www.nowcoder.com/questionTerminal/86ede762b450404dbab59352963378e9 /** * *作者: ...

  6. 自动部署Asp.Net Core到Docker

    原文链接:个人博客:自动部署Asp.Net Core至Docker 本文简介 最近在开发一个管理系统,代码框架是用的前后台分离的方式 后台使用的是Asp.Net Core平台,开发所有业务,向前台提供 ...

  7. 这个爬虫JS逆向加密任务,你还不来试试?逆向入门级,适合一定爬虫基础的人

    友情提示:在博客园更新比较慢,有兴趣的关注知识图谱与大数据公众号吧.这次选择苏宁易购登录密码加密,如能调试出来代表你具备了一定的JS逆向能力,初学者建议跟着内容调试一波,尽量独自将JS代码抠出来,实在 ...

  8. vue前端工程化

    今日目标 1.能够了解模块化的相关规范 2.了解webpack3.了解使用Vue单文件组件4.能够搭建Vue脚手架 5.掌握Element-UI的使用 1.模块化的分类 A.浏览器端的模块化   1) ...

  9. .net技术栈转型心路历程分享

    一.概要 本篇文章针对的是,长年写客户端(WPF/winfrom/delphi)的小伙伴想转后台写数据服务(asp.net mvc webapi , socket)或者想转其它技术,却又不知道改如何下 ...

  10. element UI dialog 固定高度 且关闭时清空数据

    解决方法:在dialog里写一个div ,div的大小设置为相对视窗的大小就行 <el-dialog title="xxx" :visible.sync="dial ...